using System;
using System.Windows.Forms;
using System.Drawing;

class MyForm : Form
{
    int cx;
    int cy;

    MyForm ()
    {
        Text = "Mouse Tracker";

        Graphics g = Graphics.FromHwnd (Handle);
        SizeF size = g.MeasureString ("MMMM, MMMM", Font);
        cx = (Convert.ToInt32 (size.Width) / 2) + 8;
        cy = (Convert.ToInt32 (size.Height) / 2) + 8;
        g.Dispose ();
    }

    protected override void OnMouseMove (MouseEventArgs e)
    {
        Graphics g = Graphics.FromHwnd (Handle);
        EraseCoordinates (g);
        ShowCoordinates (e.X, e.Y, g);
        g.Dispose ();
    }

    protected override void OnMouseLeave (EventArgs e)
    {
        Graphics g = Graphics.FromHwnd (Handle);
        EraseCoordinates (g);
        g.Dispose ();
    }

    void EraseCoordinates (Graphics g)
    {
        int x = ClientRectangle.Width / 2;
        int y = ClientRectangle.Height / 2;

        SolidBrush brush = new SolidBrush (BackColor);
        g.FillRectangle (brush, x - cx, y - cy, x + cx, y + cy);
        brush.Dispose ();
    }

    void ShowCoordinates (int x, int y, Graphics g)
    {
        StringFormat format = new StringFormat ();
        format.Alignment = StringAlignment.Center;
        format.LineAlignment = StringAlignment.Center;

        string coords = String.Format ("{0}, {1}", x, y);

        SolidBrush brush = new SolidBrush (Color.Black);
        g.DrawString (coords, Font, brush, ClientRectangle, format);
        brush.Dispose ();
    }

    static void Main ()
    {
        Application.Run (new MyForm ());
    }
}