#include <windows.h>
#include <httpext.h>
#include <string.h>
#include <stdlib.h>

int GetParameter (LPSTR pszQueryString, LPSTR pszParameterName);

BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD fdwReason,
    LPVOID lpvReserved)
{
    return (TRUE);
}

BOOL WINAPI GetExtensionVersion (HSE_VERSION_INFO* pVer)
{
    pVer->dwExtensionVersion = 
        MAKELONG (HSE_VERSION_MINOR, HSE_VERSION_MAJOR);
    lstrcpy (pVer->lpszExtensionDesc, "Calc ISAPI Extension");
    return (TRUE);
}

DWORD WINAPI HttpExtensionProc (EXTENSION_CONTROL_BLOCK* pECB)
{
    static char* szPrePostbackMessage = 
        "<html>\r\n"                                    \
        "<body>\r\n"                                    \
        "<form>\r\n"                                    \
        "<input type=\"text\" name=\"op1\" />\r\n"      \
        "+\r\n"                                         \
        "<input type=\"text\" name=\"op2\" />\r\n"      \
        "<input type=\"submit\" value=\"  =  \" />\r\n" \
        "</form>\r\n"                                   \
        "</body>\r\n"                                   \
        "</html>";

    static char* szPostPostbackMessage = 
        "<html>\r\n"                                            \
        "<body>\r\n"                                            \
        "<form>\r\n"                                            \
        "<input type=\"text\" name=\"op1\" value=\"%d\" />\r\n" \
        "+\r\n"                                                 \
        "<input type=\"text\" name=\"op2\" value=\"%d\" />\r\n" \
        "<input type=\"submit\" value=\"  =  \" />\r\n"         \
        "%d\r\n"                                                \
        "</form>\r\n"                                           \
        "</body>\r\n"                                           \
        "</html>";

    //
    // Build the response message body.
    //
    char szMessage[512];

    if (lstrlen (pECB->lpszQueryString) == 0) {
        // If the query string is empty, return a page that shows
        // an empty calculator.
        lstrcpy (szMessage, szPrePostbackMessage);
    }
    else {
        // If the query string is not empty, extract the user input,
        // process it, and return a page that shows inputs and outputs.
        int a = GetParameter (pECB->lpszQueryString, "op1");
        int b = GetParameter (pECB->lpszQueryString,"op2");
        wsprintf (szMessage, szPostPostbackMessage, a, b, a + b);
    }

    //
    // Build the response message header.
    //
    char szHeader[128];
    DWORD dwCount = lstrlen (szMessage);

    wsprintf (szHeader, "Content-type: text/html\r\n" \
        "Content-Length: %lu\r\n\r\n", dwCount);

    //
    // Output the response message header.
    //
    HSE_SEND_HEADER_EX_INFO shei;
    shei.pszStatus = "200 OK";
    shei.pszHeader = szHeader;
    shei.cchStatus = lstrlen (shei.pszStatus);
    shei.cchHeader = lstrlen (shei.pszHeader);
    shei.fKeepConn = FALSE;
	
    pECB->ServerSupportFunction (pECB->ConnID,
        HSE_REQ_SEND_RESPONSE_HEADER_EX, &shei, NULL, NULL);  

    //
    // Output the response message body.
    //
    pECB->WriteClient (pECB->ConnID, szMessage, &dwCount, 0); 

    //
    // Indicate that the request was processed successfully.
    //
    return HSE_STATUS_SUCCESS;
}

int GetParameter (LPSTR pszQueryString, LPSTR pszParameterName)
{
    char* p = strstr (pszQueryString, pszParameterName);

    if (p != NULL) {
        p += strlen (pszParameterName) + 1;
        for (char* tmp = p; *tmp != '&' && *tmp != 0; tmp++);
        int len = tmp - p;
        char* buffer = new char[len + 1];
        strncpy (buffer, p, len);
        int val = atoi (buffer);
        delete buffer;
        return val;
    }
    return 0;
}