<%@ Import Namespace=System.Data %>

<html>
  <body>
    <h1>Currency Converter</h1>
    <hr>
    <form runat="server">
      Target Currency<br>
      <asp:ListBox ID="Currencies" Width="256" RunAt="server" /><br>
      <br>
      Amount in U.S. Dollars<br>
      <asp:TextBox ID="USD" Width="256" RunAt="server" /><br>
      <br>
      <asp:Button Text="Convert" ID="ConvertButton" Width="256"
        RunAt="server" /><br>
      <br>
      <asp:Label ID="Output" RunAt="server" />
    </form>
  </body>
</html>

<script language="C#" runat="server">
  void Page_Init (Object sender, EventArgs e)
  {
      // Wire the Convert button to OnConvert
      ConvertButton.Click += new EventHandler (OnConvert);
  }

  void Page_Load (Object sender, EventArgs e)
  {
      // If this isn't a postback, initialize the ListBox
      if (!IsPostBack) {
          DataSet ds = new DataSet ();
          ds.ReadXml (Server.MapPath ("Rates.xml"));
          Currencies.DataSource = ds;
          Currencies.DataTextField = "Currency";
          Currencies.DataValueField = "Exchange";
          Currencies.DataBind ();
          Currencies.SelectedIndex = 0;
      }
  }

  void OnConvert (Object sender, EventArgs e)
  {
      // Perform the conversion and display the results
      try {
          decimal dollars = Convert.ToDecimal (USD.Text);
          decimal rate =
              Convert.ToDecimal (Currencies.SelectedItem.Value);
          decimal amount = dollars * rate;
          Output.Text = amount.ToString ("f2");
      }
      catch (FormatException) {
          Output.Text = "Error";
      }
  }
</script>