using System;
using System.Web.UI;

namespace Wintellect
{
    public class MessageButton : Control
    {
        string MyText = "";
        string MyMessage = "";

        public string Text
        {
            get { return MyText; }
            set { MyText = value; }
        }

        public string Message
        {
            get { return MyMessage; }
            set { MyMessage = value; }
        }

        protected override void OnPreRender (EventArgs e)
        {
            Page.RegisterClientScriptBlock (
                "MessageButtonScript",
                "<script language=\"javascript\">\n" +
                "<!--\n"                             +
                "function doAlert (message)\n"       +
                "{\n"                                +
                "    alert (message);\n"             +
                "}\n"                                +
                "-->\n"                              +
                "</script>"
            );
        }

        protected override void Render (HtmlTextWriter writer)
        {
            writer.WriteBeginTag ("input");
            writer.WriteAttribute ("type", "submit");
            writer.WriteAttribute ("name", UniqueID);

            if (ID != null)
                writer.WriteAttribute ("id", ClientID);

            if (Text.Length > 0)
                writer.WriteAttribute ("value", Text);

            if (Message.Length > 0)
                writer.WriteAttribute ("onclick",
                    "javascript:doAlert (\'" + Message + "\')");

            writer.Write (HtmlTextWriter.TagRightChar);
        }
    }
}