using System;
using System.Web.UI;

namespace Wintellect
{
    public class MessageButton : Control
    {
        string MyText = "";
        string MyMessage = "";

        public string Text
        {
            get { return MyText; }
            set { MyText = value; }
        }

        public string Message
        {
            get { return MyMessage; }
            set { MyMessage = value; }
        }

        protected override void OnPreRender (EventArgs e)
        {
            Page.RegisterClientScriptBlock (
                "MessageButtonRemoteScript",
                "<script language=\"javascript\" " +
                    "src=\"/JScript/MessageButton.js\"></script>");
        }

        protected override void Render (HtmlTextWriter writer)
        {
            writer.WriteBeginTag ("input");
            writer.WriteAttribute ("type", "submit");
            writer.WriteAttribute ("name", UniqueID);

            if (ID != null)
                writer.WriteAttribute ("id", ClientID);

            if (Text.Length > 0)
                writer.WriteAttribute ("value", Text);

            if (Message.Length > 0)
                writer.WriteAttribute ("onclick",
                    "javascript:doAlert (\'" + Message + "\')");

            writer.Write (HtmlTextWriter.TagRightChar);
        }
    }
}