using System;
using System.Web.UI;

namespace Wintellect
{
    public class MyLinkButton : Control, IPostBackEventHandler
    {
        string MyText = "";
        public event EventHandler Click;

        public string Text
        {
            get { return MyText; }
            set { MyText = value; }
        }

        public void RaisePostBackEvent (string eventArgument)
        {
            if (Click != null)
                Click (this, new EventArgs ());
        }

        protected override void Render (HtmlTextWriter writer)
        {
            // Output an <a> tag
            writer.WriteBeginTag ("a");
            if (ID != null)
                writer.WriteAttribute ("id", ClientID);
            writer.WriteAttribute ("href", "javascript:" +
                Page.GetPostBackEventReference (this));
            writer.Write (HtmlTextWriter.TagRightChar);

            // Output the text bracketed by <a> and </a> tags
            if (Text.Length > 0)
                writer.Write (Text);

            // Output a </a> tag
            writer.WriteEndTag ("a");
        }
    }
}