using System;
using System.Web.UI;
using System.Collections.Specialized;

namespace Wintellect
{
    public class MyTextBox : Control, IPostBackDataHandler
    {
        public event EventHandler TextChanged;

        public string Text
        {
            get
            {
                string text = (string) ViewState["MyText"];
                return (text == null) ? "" : text;
            }
            set { ViewState["MyText"] = value; }
        }

        public bool LoadPostData (string postDataKey,
            NameValueCollection postCollection)
        {
            string temp = Text;
            Text = postCollection[postDataKey];
            return (temp != Text);
        } 

        public void RaisePostDataChangedEvent ()
        {
            if (TextChanged != null)
                TextChanged (this, new EventArgs ()); // Fire event
        }

        protected override void Render (HtmlTextWriter writer)
        {
            writer.WriteBeginTag ("input");
            writer.WriteAttribute ("type", "text");
            writer.WriteAttribute ("name", UniqueID);

            if (ID != null)
                writer.WriteAttribute ("id", ClientID);

            if (Text.Length > 0)
                writer.WriteAttribute ("value", Text);

            writer.Write (HtmlTextWriter.TagRightChar);
        }
    }
}