using System;
using System.Web.UI;

namespace Wintellect
{
    public class NumTextBox : Control
    {
        string MyText = "";

        string IEClientScriptBlock =
            "<script language=\"javascript\">\n"               +
            "<!--\n"                                           +
            "var keys = new Array (8, 9, 13, 33, 34, 35, "     +
                "36, 37, 39, 45, 46);\n"                       +
            "function isKeyValid (keyCode)\n"                  +
            "{\n"                                              +
            "    return ((keyCode >= 48 && keyCode <= 57) || " +
                "isAuxKey (keyCode));\n"                       +
            "}\n"                                              +
            "function isAuxKey (keyCode)\n"                    +
            "{\n"                                              +
            "    for (i=0; i<keys.length; i++)\n"              +
            "        if (keyCode == keys[i])\n"                +
            "            return true;\n"                       +
            "    return false;\n"                              +
            "}\n"                                              +
            "-->\n"                                            +
            "</script>";

       string NetscapeClientScriptBlock =
            "<script language=\"javascript\">\n"               +
            "<!--\n"                                           +
            "function isKeyValid (keyCode)\n"                  +
            "{\n"                                              +
            "    return ((keyCode >= 48 && keyCode <= 57) || " +
                "keyCode == 8 || keyCode == 13);\n"            +
            "}\n"                                              +
            "-->\n"                                            +
            "</script>";

        public string Text
        {
            get { return MyText; }
            set
            {
                // Make sure value is numeric before storing it
                Convert.ToInt64 (value);
                MyText = value;
            }
        }

        protected override void OnPreRender (EventArgs e)
        {
            string browser = Context.Request.Browser.Type.ToUpper ();
            int version = Context.Request.Browser.MajorVersion;

            if (browser.IndexOf ("IE") > -1 && version >= 4)
                Page.RegisterClientScriptBlock ("NumTextBoxScript",
                    IEClientScriptBlock);
            else if (browser.IndexOf ("NETSCAPE") > -1 && version >= 4)
                Page.RegisterClientScriptBlock ("NumTextBoxScript",
                    NetscapeClientScriptBlock);
        }

        protected override void Render (HtmlTextWriter writer)
        {
            string browser = Context.Request.Browser.Type.ToUpper ();
            int version = Context.Request.Browser.MajorVersion;

            writer.WriteBeginTag ("input");
            writer.WriteAttribute ("type", "text");
            writer.WriteAttribute ("name", UniqueID);

            if (ID != null)
                writer.WriteAttribute ("id", ClientID);

            if (Text.Length > 0)
                writer.WriteAttribute ("value", Text);

            if (browser.IndexOf ("IE") > -1 && version >= 4)
                writer.WriteAttribute ("onkeydown",
                    "javascript:return isKeyValid (window.event.keyCode)");
            else if (browser.IndexOf ("NETSCAPE") > -1 && version >= 4)
                writer.WriteAttribute ("onkeydown",
                    "javascript:return isKeyValid (event.which)");

            writer.Write (HtmlTextWriter.TagRightChar);
        }
    }
}