<%@ Import NameSpace="System.IO" %>

<script language="C#" runat="server">
  static string _path;

  void Application_Start ()
  {
      StreamReader reader = null;

      try {
          // If Count.txt exists, read the count from it and
          // store the count in application state
          _path = Server.MapPath ("/Count.txt");
          reader = new StreamReader (_path);
          string line = reader.ReadLine ();
          int count = Convert.ToInt32 (line);
          Application["Count"] = count;
      }
      catch (Exception) {
          // If Count.txt does not exist or contains an invalid
          // count, store a 0 in application state
          Application["Count"] = 0;
      }
      finally {
          // Close the StreamReader
          if (reader != null)
              reader.Close ();
      }
  }

  void Application_End ()
  {
      StreamWriter writer = null;

      try {
          // Save the current count in Count.txt
          writer = new StreamWriter (_path, false);
          writer.Write (Application["Count"]);
      }
      finally {
          // Close the StreamWriter
          if (writer != null)
              writer.Close ();
      }
  }
</script>