using System;
using System.Threading;

class MyApp
{
    static AutoResetEvent are1 = new AutoResetEvent (false);
    static AutoResetEvent are2 = new AutoResetEvent (false);

    static void Main ()
    {
        try {
            // Create two threads
            Thread thread1 =
                new Thread (new ThreadStart (ThreadFuncEven));
            Thread thread2 =
                new Thread (new ThreadStart (ThreadFuncOdd));

            // Start the threads
            thread1.Start ();
            thread2.Start ();

            // Wait for the threads to end
            thread1.Join ();
            thread2.Join ();
        }
        finally {
            // Close the events
            are1.Close ();
            are2.Close ();
        }
    }

    static void ThreadFuncEven ()
    {
        for (int i=0; i<100; i+=2) {
            Console.WriteLine (i);  // Output the next even number
            are1.Set ();            // Release the other thread
            are2.WaitOne ();        // Wait for the other thread
        }
    }

    static void ThreadFuncOdd ()
    {
        for (int i=1; i<101; i+=2) {
            are1.WaitOne ();        // Wait for the other thread
            Console.WriteLine (i);  // Output the next odd number
            are2.Set ();            // Release the other thread
        }
    }
}